/**
 * Pallet Table
 * @type Boolean
 */
var change_me_to_define_pallet = false;

var hide_notification_other = function () {
    /* Hide other notifications */
    jQuery(".pallet_package_msg").hide();
};

/**
 * reset popup form box sizing
 * @returns {undefined}
 */
var en_pallet_reset_popup_box_sizing_form = function () {
    jQuery(".err").html("");
    jQuery('.add_pallet_popup #en_pallet_sizing_input_fields input').removeClass('red-border');
    jQuery("#en_pallet_sizing_input_fields input").val("");
    jQuery(".girth_error").hide();
    jQuery("#en_pallet_available").prop('checked', true);

};

var en_pallet_show_popup = function () {
    jQuery(".pallet_package_msg").hide();
    jQuery(".en_add_pallet_overlay").css({visibility: "visible", opacity: "1"});
};

var en_pallet_hide_popup = function () {
    jQuery(".en_add_pallet_overlay").css({visibility: "hidden", opacity: "0"});
};

/**
 * trim function remove white spaces ..
 * @param {type} box_sizing_row
 * @returns {String}
 */
var en_woo_pallet_trim_string = function (pallet_row) {
    return jQuery.trim(pallet_row);
};

var edit_pallet_click = function () {
    /* Show Popup */

    jQuery('.add_pallet_popup #en_pallet_sizing_input_fields input').removeClass('red-border');

    jQuery("#en_pallet_sizing_input_fields #en_pallet_nickname").val(jQuery(".en_pallet_nickname_table").text());
    jQuery("#en_pallet_sizing_input_fields #en_pallet_sizing_length").val(jQuery(".en_pallet_sizing_length_table").text());
    jQuery("#en_pallet_sizing_input_fields #en_pallet_width").val(jQuery(".en_pallet_width_table").text());
    jQuery("#en_pallet_sizing_input_fields #en_pallet_sizing_height").val(jQuery(".en_pallet_sizing_height_table").text());

    jQuery("#en_pallet_sizing_input_fields #en_pallet_sizing_pallet_height").val(jQuery(".en_pallet_sizing_pallet_height_table").text());

    jQuery("#en_pallet_sizing_input_fields #en_pallet_sizing_max_weight").val(jQuery(".en_pallet_sizing_max_weight_table").text());
    jQuery("#en_pallet_sizing_input_fields #en_pallet_sizing_weight").val(jQuery(".en_pallet_sizing_weight_table").text());


    /* Available checkbox */
    var available = en_woo_pallet_trim_string(jQuery(".en_pallet_available").text());

    if (available == "Yes") {
        jQuery("#en_pallet_sizing_input_fields #en_pallet_available").prop('checked', true);
    }
    if (available == "No") {
        jQuery("#en_pallet_sizing_input_fields #en_pallet_available").prop('checked', false);
    }

    en_pallet_show_popup();

    return false;
};

/**
 * valid_number validation
 * @param {type} value
 * @returns {Boolean}
 */
var valid_number = function (value) {
    var validNum = false;

    if (value == '' || (value == parseInt(value)) || (value == parseFloat(value))) {
        validNum = true;
    }

    return validNum;
};

/**
 * Integer validation
 * @param {type} str
 * @returns {Boolean}
 */
var is_normal_integer = function (str) {// non decimal values
    var n = Math.floor(Number(str));
    return String(n) === str && n > 0;
};

/**
 * validate string from box sizning popup form fields validation
 * @param {type} string
 * @returns {String|Boolean}
 */
var en_validate_string_pallets = function (string, id) {
    /* Skip nickname for validation */
    if (id == "en_pallet_nickname" && string != '') {
        return true;
    }
    var charReg = /^\s*[a-zA-Z0-9 d+\.\d{0,4},\s]+\s*$/;

    if (string == '') {
        return 'empty';
    }
    if (string == undefined) {
        return 'undefined';
    }
    if (charReg.test(string)) {
        return true;
    } else {
        return false;
    }
};

/**
 * all form validation box sizing
 * @param {type} form_id
 * @returns {Boolean}
 */
var en_validate_input_fields_for_pallets = function (form_id) {
    var _has_err = true;
    jQuery(form_id + " input[type='text']").each(function () {
        var input = jQuery(this).val();
        var id = jQuery(this).attr('id');

        var _response = en_validate_string_pallets(input, id);

        if (_response != "empty" && _response != "undefined" && _response != false) {
            _response = (jQuery(this).data('type') == 'number') ? valid_number(jQuery.trim(input)) : ((jQuery(this).data('type') == 'int') ? is_normal_integer(jQuery.trim(input)) : _response);
        }

        var error_element = jQuery(this).parent().find('.err');
        jQuery(error_element).html('');
        jQuery(this).removeClass('red-border');
        var error_text = jQuery(this).attr('title');
        var optional = jQuery(this).data('optional');
        optional = (optional === undefined) ? 0 : 1;
        error_text = (error_text != undefined) ? error_text : '';

        if ((optional == 0) && (_response == false || _response == 'empty')) {
            if (_response == 'empty') {
                error_text = error_text + ' is required.';
            }
            if (_response == false) {
                error_text = error_text + ' not valid.';
            }

            jQuery(error_element).html(error_text);
            jQuery(this).addClass('red-border');
        }

        _has_err = (_response != true && optional == 0) ? false : _has_err;

    });

    return _has_err;
};

/**
 * box sizing ajax request....
 * @param array data
 * @returns {response|jqXHR}
 */
var en_pallet_ajax_req = function (data) {

    var ajaxResponse = jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: data,
        async: false,
        beforeSend: function () {

        },
        success: function (response) {

            ajaxResponse = response;
        },
        error: function () {

            console.log('error');
        }
    });

    return ajaxResponse;
};

var available = function () {
    var available_text = jQuery(".en_pallet_available").text();
    var data = {available_text: available_text, action: 'available_text'};
    var response = en_pallet_ajax_req(data);
    response = jQuery.parseJSON(response.responseText);
    if (typeof response['html'] != 'undefined') {
        jQuery('.en_pallet_available').text(response['html']);
    }

    jQuery('.en_pallet_notification_data_saved').show("slow");
    setTimeout(function () {
        jQuery('.en_pallet_notification_data_saved').hide('slow');
    }, 5000);
};

/**
 * Delete box sizing.
 * @param int postId
 * @returns boolean
 */
var delete_pallet_click = function () {
    window.location.href = jQuery('.delete_pallet_btn').attr('href');
    jQuery('.cancel_delete_pallet').on('click', function () {

        window.location.href = jQuery('.cancel_delete_pallet').attr('href');
        /* Unbind click to avoid multiple click issue */
        jQuery('.cancel_delete_pallet').unbind('click');
    });
    jQuery('.confirm_delete_pallet').on('click', function () {

        var data = {action: 'delete_pallet'};
        var response = en_pallet_ajax_req(data);
        response = jQuery.parseJSON(response.responseText);
        if (typeof response['html'] != 'undefined') {
            jQuery('.en_pallet_list tbody tr').remove();
        }


        jQuery('.woocommerce-add-button').show();
//        jQuery('.woocommerce-add-button').text("Add Pallet");
//        jQuery('.woocommerce-add-button').removeAttr("onClick");
//        jQuery('.woocommerce-add-button').attr("onClick" , "return add_pallet_popup_click()");

        jQuery('.en_pallet_notification_delete').show("slow");
        setTimeout(function () {
            jQuery('.en_pallet_notification_delete').hide('slow');
        }, 5000);
        /* Unbind click to avoid multiple click issue */
        jQuery('.confirm_delete_pallet').unbind('click');
    });


};

var add_pallet_popup_click = function () {
    change_me_to_define_pallet = true;
    en_pallet_reset_popup_box_sizing_form();
    en_pallet_show_popup();
};

jQuery(document).ready(function () {

    jQuery("#en_pallet_sizing_plugin_name").closest('tr').addClass('en_pallet_sizing_plugin_name_style');
    jQuery("#en_pallet_sizing_subscription_status").closest('tr').addClass('en_pallet_sizing_subscription_status_style');
    jQuery("#en_pallet_sizing_current_subscription").closest('tr').addClass('en_pallet_sizing_current_subscription');
    jQuery("#en_pallet_sizing_current_usage").closest('tr').addClass('en_pallet_sizing_current_usage');

    /**
     * when user switch from disable to plan popup hide
     * @returns {jQuery}
     */
    var en_woo_pallet_addons_popup_notifi_disabl_to_plan_hide = function () {
        return jQuery(".en_notification_disable_to_plan_overlay_pallet").css({
            display: 'none',
            visibility: "hidden",
            opacity: "0"
        });
    };

    /**
     * when user switch from disable to plan popup show
     * @returns {jQuery}
     */
    var en_woo_addons_popup_notifi_disabl_to_plan_show_pallet = function () {
        var selected_plan = jQuery("#en_pallet_packaging_options_plans").find("option:selected").text();
        jQuery(".en_notification_disable_to_plan_overlay_pallet:last").find("#selected_plan_popup_pallet").text(selected_plan);
        // jQuery("#selected_plan_popup_pallet").text(selected_plan);
        return jQuery(".en_notification_disable_to_plan_overlay_pallet").css({
            display: 'block',
            visibility: "visible",
            opacity: "1"
        });
    };

    /**
     * When user from disable to plan popup actions.
     * @returns {undefined}
     */
    jQuery(".cancel_plan").on('click', function () {
        en_woo_pallet_addons_popup_notifi_disabl_to_plan_hide();
        jQuery('#en_pallet_packaging_options_plans').prop('selectedIndex', 0);
        return false;
    });
    /**
     * Confirm click function.
     */
    jQuery(".confirm_plan").on('click', function () {
        var params = "";
        en_woo_pallet_addons_popup_notifi_disabl_to_plan_hide();
        var monthly_pckg = jQuery("#en_pallet_packaging_options_plans").val();
        var plugin_name = jQuery("#en_pallet_sizing_plugin_name").attr("placeholder");

        var data = {
            plugin_name: plugin_name,
            selected_plan: monthly_pckg,
            action: 'en_woo_pallet_addons_upgrade_plan_submit'
        };
        params = {
            loading_id: "en_pallet_packaging_options_plans",
            message_id: "plan_to_disable_message",
            disabled_id: "en_pallet_packaging_options_plans",
            message_ph: " Success! Your choice of plans has been updated. "

        };

        pallet_ajax_request(params, data, pallet_monthly_packg_response);
        return false;
    });

    var pallet_monthly_packg_response = function (params, response) {
        var pars_response = jQuery.parseJSON(response);

        if (pars_response.severity == "SUCCESS") {
            if (pars_response.subscription_packages_response_for_pallet == "yes") {

                jQuery(".en_pallet_sizing_current_subscription .description").html(pars_response.current_subscription);
                jQuery(".en_pallet_sizing_current_usage .description").html(pars_response.current_usage);
//            jQuery("#en_pallet_sizing_current_usage").next('.description').html(pars_response.current_usage);
                jQuery("#en_pallet_sizing_subscription_status").attr("placeholder", "yes");
            }

            if (typeof params.message_ph != 'undefined' && params.message_ph.length > 0) {
                // jQuery(".pallet-detail p:nth-child(1)").after('<div class="alert-plan-messages alert-success pallet_package_msg">  ' + params.message_ph + '   </div>');
                jQuery(".pallet-detail").before('<div class="alert-plan-messages alert-success pallet_package_msg">  ' + params.message_ph + '   </div>');
            }

            suspend_automatic_detection_pallet();

        } else {
            // jQuery(".pallet-detail p:nth-child(1)").after(' <div class="alert-plan-messages alert-danger pallet_package_msg" >  ' + pars_response.Message + '  </div>');
            jQuery(".pallet-detail").before('<div class="alert-plan-messages alert-danger pallet_package_msg" >  ' + pars_response.Message + '  </div>');
            jQuery('#en_pallet_packaging_options_plans').prop('selectedIndex', 0);
        }

        jQuery("#box_sizing_plan_auto_renew").focus();
    };


    /**
     * Monthly package select actions.
     * @param string monthly_pckg
     * @returns boolean
     */
    var en_woo_addons_monthly_packg_box = function (monthly_pckg) {
        jQuery(".pallet_package_msg").remove();
        var plugin_name = jQuery("#en_pallet_sizing_plugin_name").attr("placeholder");
        var data = {
            plugin_name: plugin_name,
            selected_plan: monthly_pckg,
            action: 'en_woo_pallet_addons_upgrade_plan_submit'
        };
        var params = "";

        if (window.existing_plan_pallet == "disable") {
            en_woo_addons_popup_notifi_disabl_to_plan_show_pallet();
            return false;
        } else if (monthly_pckg == "disable") {

            params = {
                loading_id: "en_pallet_packaging_options_plans",
                disabled_id: "en_pallet_packaging_options_plans",
                message_ph: "You have disabled the Standard Packaging plugin. The plugin will stop working when the current plan is depleted or expires."
            };
        } else {
            params = {
                loading_id: "en_pallet_packaging_options_plans",
                disabled_id: "en_pallet_packaging_options_plans",
                message_ph: " Success! Your choice of plans has been updated. "
            };
        }

        pallet_ajax_request(params, data, pallet_monthly_packg_response);
    };


    var suspend_automatic_detection_pallet = function (params, response) {
        var selected_plan = jQuery("#en_pallet_packaging_options_plans").val();
        window.existing_plan_pallet = selected_plan;
        var suspend_automatic = jQuery("#suspend_automatic_detection_of_pallets").prop("checked");
        var subscription_status = jQuery("#en_pallet_sizing_subscription_status").attr("placeholder");

        if (subscription_status == "yes") {

            jQuery("#suspend_automatic_detection_of_pallets").prop('disabled', false);
            jQuery("label[for='en_pallet_packaging_options_plans']").text("Auto-renew");
            if (suspend_automatic) {

                jQuery(".add_box .add_box_packaging_click").addClass("disable");
            } else {
                jQuery(".add_box .add_box_packaging_click").removeClass("disable");

            }
        } else {

            jQuery(".add_box .add_box_packaging_click").addClass("disable");
            jQuery("label[for='en_pallet_packaging_options_plans']").text("Select a plan");
            jQuery("#suspend_automatic_detection_of_pallets").prop({checked: false, disabled: true});
        }
    };

    /**
     * existing user plan for box sizing.
     * @param {type} params
     * @param {type} data
     * @param {type} call_back_function
     * @returns {undefined}
     */
    suspend_automatic_detection_pallet();

    function pallet_ajax_request(params, data, call_back_function) {

        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: data,
            beforeSend: function () {
                (typeof params.loading_id != 'undefined' && params.loading_id.length > 0) ? jQuery("#" + params.loading_id).css('background', 'rgba(255, 255, 255, 1) url(' + sp_plugins_url + '/pallet-packaging/assets/images/processing.gif) no-repeat scroll 50% 50%') : "";
                (typeof params.disabled_id != 'undefined' && params.disabled_id.length > 0) ? jQuery("#" + params.disabled_id).prop({disabled: true}) : "";
                (typeof params.loading_msg != 'undefined' && params.loading_msg.length > 0 && typeof params.disabled_id != 'undefined' && params.disabled_id.length > 0) ? jQuery("#" + params.disabled_id).after(params.loading_msg) : "";
            },
            success: function (response) {
                console.log(response);
                jQuery('.notice-dismiss-bin-php').remove();
                (typeof params.loading_id != 'undefined' && params.loading_id.length > 0) ? jQuery("#" + params.loading_id).css('background', '#fff') : "";
                (typeof params.loading_id != 'undefined' && params.loading_id.length > 0) ? jQuery("#" + params.loading_id).focus() : "";
                (typeof params.disabled_id != 'undefined' && params.disabled_id.length > 0) ? jQuery("#" + params.disabled_id).prop({disabled: false}) : "";
                (typeof params.loading_msg != 'undefined' && params.loading_msg.length > 0 && typeof params.disabled_id != 'undefined' && params.disabled_id.length > 0) ? jQuery("#" + params.disabled_id).next('.suspend-loading').remove() : "";
                return call_back_function(params, response);
            },
            error: function () {
                console.log('error');
            }
        });
    }

    /**
     * plan change function for box sizing.
     */
    jQuery("#en_pallet_packaging_options_plans").on('change', function () {
        en_woo_addons_monthly_packg_box(jQuery(this).val());
        return false;
    });

    var suspend_automatic_detection_params = function () {
        return {
            loading_msg: " <span class='suspend-loading'>Loading ...</span>",
            disabled_id: "suspend_automatic_detection_of_pallets",
        };
    };

    var suspend_automatic_detection_anable = function () {
        return {
            suspend_automatic_detection_of_pallets: "yes",
            action: "suspend_automatic_detection_pallet",
        };
    };

    var suspend_automatic_detection_disabled = function () {
        var always_include_threed = jQuery(".en_woo_pallet_addons_always_include_threed_fee").attr("id");
        return {
            suspend_automatic_detection_of_pallets: "no",
            action: "suspend_automatic_detection_pallet"
        };
    };

    jQuery("#suspend_automatic_detection_of_pallets").on('click', function () {
        var data = "";
        var params = "";
        if (this.checked) {
            data = suspend_automatic_detection_anable();
            params = suspend_automatic_detection_params();
        } else {
            data = suspend_automatic_detection_disabled();
            params = suspend_automatic_detection_params();
        }
        pallet_ajax_request(params, data, suspend_automatic_detection_pallet);
    });

});

jQuery(document).ready(function () {

//  Pallet
    jQuery(".add_box").parent().closest('div').addClass('pallet-detail');

    jQuery(".en_pallet_cancel").on('click', function () {
        /* Hide add popup */
        en_pallet_reset_popup_box_sizing_form();
        en_pallet_hide_popup();
    });

    jQuery(".en_pallet_submit").on('click', function () {

        var form_data = jQuery("#en_pallet_sizing_input_fields").serialize();

        var validatForm = en_validate_input_fields_for_pallets("#en_pallet_sizing_input_fields");

        if (validatForm) {
            var data = {form_data: form_data, action: 'en_pallet_submit'};
            var response = en_pallet_ajax_req(data);

            response = jQuery.parseJSON(response.responseText);
            if (typeof response['html'] != 'undefined') {
                jQuery('.en_pallet_list tbody').html(response['html']);

                /* Hide add popup */
                en_pallet_hide_popup();

                if (change_me_to_define_pallet) {
                    jQuery('.woocommerce-add-button').hide();
//                    jQuery('.woocommerce-add-button').removeAttr('onClick');
//                    jQuery('.woocommerce-add-button').text("Define Pallet");
//                    jQuery('.woocommerce-add-button').attr("onClick" , "return edit_pallet_click()");

                    change_me_to_define_pallet = false;
                }

                jQuery('.en_pallet_notification_data_saved').show("slow");
                setTimeout(function () {
                    jQuery('.en_pallet_notification_data_saved').hide('slow');
                }, 5000);
            }
        }
    });
});
