<?php

/**
 * Includes Ajax Request class
 */
if (!defined('ABSPATH')) {
    exit;
}

if (!class_exists("EnWooPalletAddonsAjaxReqIncludes")) {

    class EnWooPalletAddonsAjaxReqIncludes extends PackagingTab {

        public $plugin_standards;
        public $selected_plan;
        public $en_box_sizing_nickname;
        public $en_box_sizing_width;
        public $en_box_sizing_weight;
        public $en_box_sizing_length;
        public $en_box_sizing_height;
        public $en_box_sizing_max_weight;
        public $fedex_box_type;
        public $en_box_sizing_action;
        public $en_box_sizing_row_id;
        public $en_box_sizing_available;
        public $post_title;
        public $meta_key;
        public $post_meta;
        public $wp_post_id;
        public $success;
        public $postId;
        public $En_Woo_Addon_Box_Size_Detection_Template;

        /**
         * Constructer
         */
        public function __construct() {
            
            /**
            * Pallet table save ajax request
            */
            add_action('wp_ajax_nopriv_en_pallet_submit', array($this, 'en_pallet_submit'));
            add_action('wp_ajax_en_pallet_submit', array($this, 'en_pallet_submit'));

            /**
            * Pallet available
            */
            add_action('wp_ajax_nopriv_available_text', array($this, 'available_text'));
            add_action('wp_ajax_available_text', array($this, 'available_text'));

            /**
            * Pallet Delete
            */
            add_action('wp_ajax_nopriv_delete_pallet', array($this, 'delete_pallet'));
            add_action('wp_ajax_delete_pallet', array($this, 'delete_pallet'));
            
            /**
            * Pallet ajax request
            */
            add_action('wp_ajax_nopriv_en_woo_pallet_addons_upgrade_plan_submit', array($this, 'en_woo_pallet_addons_upgrade_plan_submit'));
            add_action('wp_ajax_en_woo_pallet_addons_upgrade_plan_submit', array($this, 'en_woo_pallet_addons_upgrade_plan_submit'));


            /**
            * Suspend automatic detection of box sizing.
            */
            add_action('wp_ajax_nopriv_suspend_automatic_detection_pallet', array($this, 'suspend_automatic_detection_pallet'));
            add_action('wp_ajax_suspend_automatic_detection_pallet', array($this, 'suspend_automatic_detection_pallet'));


        }
        
        /**
        * Pallet Delete
        */
        public function delete_pallet()
        {
            delete_option('pallet');
            echo json_encode(array('html' => TRUE)); exit;
        }
        
        /**
        * Pallet available
        */
        public function available_text()
        {
            $available_text = (isset($_POST['available_text'])) ? sanitize_text_field($_POST['available_text']) : "";
            $pallet_detail = json_decode(get_option('pallet') , TRUE);
            if(strlen($available_text) > 0)
            {
                $pallet_detail['en_pallet_available'] = ($available_text == "Yes") ? "No" : "Yes";
                update_option("pallet", json_encode($pallet_detail));

                echo json_encode(array('html' => $pallet_detail['en_pallet_available'])); exit;
            }

            echo json_encode(array('html' => 'No')); exit;
        }
        
        public function en_pallet_submit()
        {
            $pallet_detail = array();
            parse_str($_POST['form_data'], $pallet_detail);
            $html = "";

            if(isset($pallet_detail) && (!empty($pallet_detail)))
            {
                $pallet_detail['en_pallet_available'] = (isset($pallet_detail['en_pallet_available'])) ? (strlen($pallet_detail['en_pallet_available']) > 0) ? $pallet_detail['en_pallet_available'] : "Yes" : "No"; 

                update_option("pallet", json_encode($pallet_detail));
//                $pallet_str = '<tr><td>'.implode('</td>' . '<td>' . ""  , $pallet_detail).'</td></tr>';

                ob_start();
                echo '<tr>';
                foreach ($pallet_detail as $key => $value) {

                    $value = $key == "en_pallet_available" ? '<a class="en_pallet_available" onClick="available()">' . $value . '</a>' : $value;

                    echo '<td class="'.$key.'_table">'.$value.'</td>';
                }

                $actions .= '<td>';
                $actions .= '<a class="en_pallet_action_pallet_sizing" onClick="return edit_pallet_click()"> Edit </a> | <a class="en_pallet_action_pallet_sizing" onclick="return delete_pallet_click()" id=""> Delete </a>';
                $actions .= '</td>';

                echo $actions;

                echo '</tr>';
                $html = ob_get_clean();
            }
            echo json_encode(array('html' => $html)); exit;

        }

        /**
         * Auto detect box sizing ajax request.
         */
        public function en_woo_pallet_addons_upgrade_plan_submit() {

            $packgInd = ( isset($_POST['selected_plan']) ) ? sanitize_text_field($_POST['selected_plan']) : '';
            $plugin_name = ( isset($_POST['plugin_name']) ) ? sanitize_text_field($_POST['plugin_name']) : '';
            $this->plugin_standards = $plugin_name;
            $this->selected_plan = $packgInd;
            $action = isset($packgInd) && ($packgInd == "disable") ? "d" : "c";
            $EnWooPalletAddonsCurlReqIncludes = new EnWooPalletAddonsCurlReqIncludes();
            $status = $EnWooPalletAddonsCurlReqIncludes->smart_street_api_curl_request($action, $this->plugin_standards, $this->selected_plan);
            $status = json_decode($status, true);
            if (isset($status['severity']) && $status['severity'] == "SUCCESS") {
                if (!class_exists("PackagingTab")) {
                    include_once( addon_plugin_url . '/packaging-tab.php' );
                }
                $PackagingTab = new PackagingTab();
                $status = $PackagingTab->subscription($status);
                $status['severity'] = "SUCCESS";
            }
            echo json_encode($status);
            die();
        }

        public function suspend_automatic_detection_pallet() {
            
            $options = array();
            $suspend_automatic_detection_of_pallets = ( isset($_POST['suspend_automatic_detection_of_pallets']) ) ? sanitize_text_field($_POST['suspend_automatic_detection_of_pallets']) : '';
            (isset($suspend_automatic_detection_of_pallets) && (!empty($suspend_automatic_detection_of_pallets))) ?
                            $options["suspend_automatic_detection_of_pallets"] = $suspend_automatic_detection_of_pallets : "";
            $this->update_db($options);
            echo json_encode($options);
            die();
        }

        /**
         * Update options table.
         * @param array $options
         */
        public function update_db($options) {
            
            if (isset($options) && (is_array($options))) {
                foreach ($options as $options_name => $options_value) {
                    update_option($options_name, $options_value);
                }
            }
        }

    }

}
/* Initialize object */
new EnWooPalletAddonsAjaxReqIncludes();