<?php

//  Not allowed to access directly
if (!defined('ABSPATH')) {
    exit;
}

if (!class_exists("Packaging")) {
    class Packaging
    {
        public $order_id;
        public $pallet_nickname;

        function __construct()
        {
            add_filter('en_pallet_identify', array($this, 'en_pallet_identify'), 10, 1);
            add_filter('set_standard_packaging', array($this, 'set_standard_packaging'), 10, 1);
            add_action('woocommerce_checkout_update_order_meta', array($this, 'before_checkout_create_order'), 10, 2);
            add_action('woocommerce_order_actions', array($this, 'en_create_meta_box_pallets'), 11, 1);
        }

        public function en_create_meta_box_pallets($actions)
        {
            $this->order_id = get_the_ID();

            $bin_packaging = [];
            $order_id = get_the_ID();
            $order = wc_get_order($order_id);
            $shipping_details = $order->get_items('shipping');
            foreach ($shipping_details as $item_id => $shipping_item_obj) {
                $this->result_details = $shipping_item_obj->get_formatted_meta_data();
//                $this->shipping_method_title_for_usps[] = $shipping_item_obj->get_method_title();
            }

            $order_data = $this->result_details;

            $shipment = 'single';
            $en_data = false;
            foreach ($order_data as $key => $is_meta_data) {
                (isset($is_meta_data->key) && $is_meta_data->key === "min_prices") ? $shipment = 'multiple' : '';

                if (isset($is_meta_data->key) && $is_meta_data->key === "en_data") {
                    $en_data = true;
                    $shipment = 'multiple';
                    $order_data = $is_meta_data->value;
                }
            }

            if ($shipment == 'multiple') {
                if ($en_data) {
                    $order_data = json_decode($order_data, TRUE);
                    foreach ($order_data as $key => $meta_data) {
                        (isset($meta_data['standard_packaging']) && !empty($meta_data['standard_packaging'])) ? $bin_packaging[] = json_decode($meta_data['standard_packaging'], true) : '';
                    }
                } else {
                    $order_data = reset($order_data);
                    $order_data = json_decode($order_data->value, TRUE);
//                    $this->shipping_method_title_for_usps = [];
                    foreach ($order_data as $key => $meta_data) {
                        (isset($meta_data['meta_data']['standard_packaging']) && !empty($meta_data['meta_data']['standard_packaging'])) ? $bin_packaging[] = json_decode($meta_data['meta_data']['standard_packaging'], true) : '';
                        (isset($meta_data['meta_data']['plugin_name'])) ? $this->carrier_from_meta = $meta_data['meta_data']['plugin_name'] : '';
//                        (isset($meta_data['service_code'])) ? $this->shipping_method_title_for_usps[] = $meta_data['service_code'] : '';
                    }
                }
            } else {
                foreach ($order_data as $key => $meta_data) {
                    (isset($meta_data->key) && $meta_data->key === 'standard_packaging') ? $bin_packaging[] = json_decode($meta_data->value, true) : '';
                    (isset($meta_data->key) && $meta_data->key === 'plugin_name') ? $this->carrier_from_meta = $meta_data->value : '';
                }
            }

            $this->standard_packaging = $bin_packaging;

            add_meta_box('en_order_visual_bin_details', __('Pallet Details', 'woocommerce'), array($this, 'en_assign_pallet_details'), 'shop_order', 'normal', 'core');

            return $actions;
        }

        public function get_pallets_detail_db()
        {
            $order = new WC_Order($this->order_id);
            $_standard_packaging = array();
            foreach ($order->get_meta_data() as $key => $value) {
                $standard_packaging = $value->get_data();
                if (isset($standard_packaging['key']) && ($standard_packaging['key'] == "_standard_packaging")) {
                    $_standard_packaging = json_decode($standard_packaging['value'], TRUE);
                }
            }

            return $_standard_packaging;
        }

        public function en_assign_pallet_details()
        {
//            $standard_packaging = $this->get_pallets_detail_db();
            $standard_packaging = $this->standard_packaging;

            if (!empty($standard_packaging)) {
                $this->en_get_pallet_packed($standard_packaging);
            } else {
                echo '<p>No packaging found for this order.</p>';
            }
        }

        /**
         * Get the pallet packed
         */
        public function en_get_pallet_packed($standard_packaging)
        {

            $count = 1;

            foreach ($standard_packaging as $key => $standard_packag) {

                foreach ($standard_packag as $key => $details) {
                    if (isset($details['pallets_packed']) && (!empty($details['pallets_packed']))) {
                        $total_boxs_packet = count($details['pallets_packed']);
                        $total_items_packet = $this->en_total_items_count($details);
                        echo "<div class='en-pallet-details'>";
                        echo "<p>Number of Pallets :<span class='total_boxes_packed'><strong> " . $total_boxs_packet . "</strong></span></p>";
                        echo "<p>Total items packed :<span class='total_boxes_packed'><strong> " . $total_items_packet . "</strong></span></p>";
                        echo "<hr>";
                        $this->en_output_bins_packed($details);
                        echo "</div>";
                        $count++;
                    }
                }

            }
        }

        /**
         * Bins packets ouput.
         * @param array $bin_details
         * @param string/int $zip
         */
        public function en_output_bins_packed($details)
        {

            $main_bin_img = '';
            $item_own_pkg = '';
            $bin_count = 1;
            echo "<div class='per-package'>";
            /* Pallet packed details */
            foreach ($details['pallets_packed'] as $bin_details) {

                $this->pallet_nickname = (isset($bin_details['pallet_data']['type'], $bin_details['pallet_data']['id']) && $bin_details['pallet_data']['type'] == "item") ? $this->get_product_name($bin_details['pallet_data']['id']) : ((isset($bin_details['pallet_data']['id'])) ? $bin_details['pallet_data']['id'] : "");
                $main_bin_img = $bin_details['image_complete'];
                echo '<div class="en-pallet-' . $bin_count . '">';
                echo '<div class="en-full-row">';
                echo '<div class="en-left before-steps-info">';
                echo '<p><b>Pallet ' . $bin_count . ' of ' . count($details['pallets_packed']) . '</b></p>';
//                    echo '<p class="box-prod-title">' . get_the_title($bin_details['pallet_data']['id']) . ' <strong>' . $item_own_pkg . '</strong></p>';
                echo '<p class="box-prod-title">' . $this->pallet_nickname . '</p>';
                echo '<div class="package-dimensions">'
                    . '<p>' . $bin_details['pallet_data']['d'] . ' x ' . $bin_details['pallet_data']['w'] . ' x ' . $bin_details['pallet_data']['h'] . '</p>'
                    . '</div>';
                echo '</div>';
                echo '<div class="package-complete-image">';
                echo '<img class="package-complete-image-tag" src="' . $main_bin_img . '" />';
                echo '</div>';
                echo '</div>';
                echo '</div>';
                $this->en_output_items_packed($bin_details);
                $bin_count++;
            }
            echo "</div>";
        }

        /**
         * Get Product Name
         */
        public function get_product_name($product_id)
        {
            return get_the_title($product_id) . " (Own Pallet)";
        }

        /**
         * Items packet details.
         * @param array $bin_details
         * @param string/int $zip
         */
        public function en_output_items_packed($bin_details)
        {

            echo '<div class="package-steps-block">';
            echo "<p><strong>Steps:</strong></p>";
            $total_items_packet = count($bin_details['items']);
            $item_image = '';
            /* Items packed details */
            foreach ($bin_details['items'] as $item_details) {
                $product_title = wc_get_product($item_details['id']);
                echo '<div class="package-steps-product">';
                echo '<img class="en-prduct-steps-image" src="' . $item_details['image_sbs'] . '" />';
                echo '<div class="en-product-steps-details">';
//                echo '<p class="en-prdouct-steps-name">' . $product_title->get_name() . '</p>';
                $product_name = (isset($item_details['product_name'])) ? $item_details['product_name'] : '';
                echo '<p class="en-prdouct-steps-name">' . $product_name . '</p>';
//                    echo '<p class="en-prdouct-steps-name">' . $this->pallet_nickname . '</p>';
                echo '<p class="en-prdouct-steps-dimensions">' . $item_details['d'] . ' x ' . $item_details['w'] . ' x ' . $item_details['h'] . '</p>';
                echo '</div>';
                echo '</div>';
            }
            /* Clear the float effect */
            echo '<div class="en-clear"></div>';
            echo '</div>';
            echo '<hr>';
        }

        /**
         *  Count the items.
         * @param array $details
         */
        public function en_total_items_count($details)
        {

            $items = 0;
            foreach ($details['pallets_packed'] as $d) {
                (isset($d['items'])) ? $items += count($d['items']) : "";
            }
            return $items;
        }

        public function before_checkout_create_order($order_id, $posted)
        {
            $order = wc_get_order($order_id);
            $standard_packaging = $this->get_standard_packaging();

            if (isset($standard_packaging) && (!empty($standard_packaging))) {
                $order->update_meta_data('_standard_packaging', $standard_packaging);
                $this->unset_standard_packaging();
                $order->save();
            }
        }

        public function set_standard_packaging($standard_packaging_data)
        {
            WC()->session->set('standard_packaging', json_encode($standard_packaging_data));
        }

        public function unset_standard_packaging()
        {
            WC()->session->set('standard_packaging', array());
        }

        public function get_standard_packaging()
        {
            return WC()->session->get('standard_packaging');
        }

        public function en_pallet_identify($post_data)
        {
            $subscription_packages_falg = get_option('subscription_packages_response_for_pallet');
            $suspend_automatic_flag = get_option('suspend_automatic_detection_of_pallets');
            if ($subscription_packages_falg == "yes" && $suspend_automatic_flag != "yes") {
                $pallet = json_decode(get_option('pallet'), TRUE);
                if (isset($pallet['en_pallet_available']) && ($pallet['en_pallet_available'] == "Yes")) {
                    $post_data['standard_packaging'] = 1;
                    $post_data['standardPackaging'] = 1;
                    $post_data['pallet'] =
                        array(
                            'w' => $pallet['en_pallet_width'], // width
                            'd' => $pallet['en_pallet_sizing_length'], // lenth
                            'h' => $pallet['en_pallet_sizing_height'], // max height
                            'id' => 'pallet', // unique id
                            'id' => $pallet['en_pallet_nickname'], // unique id
                            'wg' => $pallet['en_pallet_sizing_max_weight'], // max waight
                            'max_wg' => $pallet['en_pallet_sizing_max_weight'], // max waight
                            'pallet_wg' => $pallet['en_pallet_sizing_weight'], // pallet waight
                            'pallet_h' => $pallet['en_pallet_sizing_pallet_height'], // pallet Height
                        );
                }
            }

            return $post_data;
        }

    }

    new Packaging();
}
