<?php
/*
Plugin Name: Pallet Packaging
Plugin URI: https://eniture.com/products/
Description: Identifies the optimal packaging solution using your standard pallet. For exclusive use with Eniture Technology’s LTL Freight Quotes plugins.
Version: 1.0.0
Author: Eniture Technology
Author URI: http://eniture.com/
Text Domain: eniture-technology
License: GPL version 2 or later - http://www.eniture.com/
*/

//  Not allowed to access directly
    if (!defined('ABSPATH')) {
        exit;
    }
    
    require_once ( 'pallet-plugin-details.php' );
    require_once ( 'pallet-packaging.php' );
    require_once ( 'packaging-tab.php' );
    require_once ( 'pallet-addons-curl-request.php' );
    require_once ( 'pallet-addons-ajax-request.php' );
    
    /**
    * Load script
    */
    function en_pallet_script() 
    {

        wp_enqueue_script('en_pallet_script', plugin_dir_url(__FILE__) . '/assets/js/standard-packaging-script.js', array(), '1.0.1');
        wp_localize_script('en_pallet_script', 'script', array(
            'pluginsUrl' => plugins_url(),
        ));
        wp_register_style('en_pallet_style', plugin_dir_url(__FILE__) . '/assets/css/standard-packaging-style.css', false, '1.0.1');
        wp_enqueue_style('en_pallet_style');
    }
    
    add_action('admin_enqueue_scripts', 'en_pallet_script');
    
    /**
     * globally script variable 
     */
    function pallet_admin_inline_js() 
    {
        ?>
        <script>
            var sp_plugins_url = "<?php echo plugins_url(); ?>";
        </script>
        <?php
    }
    
    add_action('admin_print_scripts', 'pallet_admin_inline_js');
